/*
 
 LCD 8 bits, a0 EN, a1 RS, b0-b7 LCD
 */

#include	<pic.h>
#include	"lcd8.h"
#include	"delay.h"
 
static bit LCD_RS	@ ((unsigned)&PORTA*8+1);	// Register select
static bit LCD_EN	@ ((unsigned)&PORTA*8+0);	// Enable


#define	LCD_STROBE	((LCD_EN = 1),(LCD_EN=0))


/* write a byte to the LCD in 4 bit mode */

void
lcd_write(unsigned char c)
{
        LCD_RS = 0;
	PORTB = c;
	LCD_STROBE;
	DelayUs(40);
}

/*
 * 	Clear and home the LCD
 */

/* write a string of chars to the LCD */

void
lcd_puts(const char * s)
{
	while(*s)
		lcd_putch(*s++);
}

/* write one character to the LCD */

void
lcd_putch(unsigned char c)
{
	LCD_RS = 1;
	PORTB = c;
	LCD_STROBE;
	DelayUs(40);
}


