// /usr/hitech/bin/picl  -16f84 -C -Zg senha.c lcd8.c delay.c
// /usr/hitech/bin/picl  -16f84 -Osenha.hex senha.obj lcd8.obj delay.obj

#include	<pic.h>
#include	"lcd.h"
#include	"delay.h"


#define up RA4
#define down RA3
#define next RA2
// senha
char senha[5];
// tentativa
char tentativa[5];
char s_aux[5];

char up_is_pressed = 1;
char down_is_pressed = 1;
char next_is_pressed = 1;

char position = 0;

char t;
int pos = 0;
int cor = 0;
int i,j;

void change(signed char x)
{

	if ( x < 0 )
	  tentativa[position]--;
	else
	  tentativa[position]++;
	lcd_write(0x80+position);
	lcd_putch(tentativa[position]);
}





main(){

  TRISA = 0x1C; // Output bits porta, xxxSE
  TRISB = 0x00; // Output bits portb 76543210

  senha[0] ='1';
  senha[1] = '2';
  senha[2] = '3';
  senha[3] = '4';
  senha[4] = '\0';

  tentativa[0] = '0';
  tentativa[1] = '0';
  tentativa[2] = '0';
  tentativa[3] = '0';
  tentativa[4] = '\0';

  lcd_write(0x0C); // liga
  lcd_write(0x01); // limpa
  lcd_write(0x80); // coluna 0, linha 0
  lcd_puts(tentativa);

  while(1){
  	if ( next & next_is_pressed ) {
		position++;
		next_is_pressed = 0;
		if ( position == 4 ) {
			for (i=0; i<5;++i)
					s_aux[i]=senha[i];
				pos=cor= 0;
				for (i=0; i<4;++i) {
					if (s_aux[i] == tentativa[i]) {
						pos++;
						s_aux[i]= 'x';
						tentativa[i]='x';
					}
				}
				for (i=0; i<4;++i) {
					if (s_aux[i]!='x') {
						for ( j=0; j<4; ++j) {
							if (s_aux[i]==tentativa[j]) {
								cor++;
								tentativa[j]='x';
								break;
							}
						}
					}
				}
				lcd_puts(" Pos= ");
				lcd_putch(48+pos);
				lcd_puts(" Cor= ");
				lcd_putch(48+cor);
				if (pos==4) lcd_puts(" Parabens, VOCE GANHOU!!");
			}
		if (position==5) {
			tentativa[0] = '0';
  			tentativa[1] = '0';
  			tentativa[2] = '0';
 			tentativa[3] = '0';
  			tentativa[4] = '\0';
			lcd_write(0x01); // limpa
  			lcd_write(0x80); // coluna 0, linha 0
  			lcd_puts(tentativa);
			position=0;}

	} else if ( next==0 && !next_is_pressed ) { // release next
		next_is_pressed = !next_is_pressed ;
	} else   if ( up & up_is_pressed ) {
		change(1);
		up_is_pressed = 0;
	} else if ( up==0 && !up_is_pressed ) { // release up
		up_is_pressed = !up_is_pressed ;
	} else   if ( down & down_is_pressed ) {
		change(-1);
		down_is_pressed = 0;
	} else if ( down==0 && !down_is_pressed ) { // release down
		down_is_pressed = !down_is_pressed ;
	}

    }
}

